Index: trunk/kernel/kernel_config.h
===================================================================
--- trunk/kernel/kernel_config.h	(revision 610)
+++ trunk/kernel/kernel_config.h	(revision 611)
@@ -128,4 +128,6 @@
 #define DEBUG_QUEUELOCK_TYPE              0    // lock type (0 is undefined)
 
+#define DEBUG_REMOTE_DIR                  0
+
 #define DEBUG_RPC_CLIENT_GENERIC          0
 #define DEBUG_RPC_SERVER_GENERIC          0
@@ -148,6 +150,8 @@
 #define DEBUG_RPC_VFS_FILE_DESTROY        0
 #define DEBUG_RPC_VFS_DEVICE_GET_DENTRY   0
+#define DEBUG_RPC_VMM_CREATE_VSEG         0
 #define DEBUG_RPC_VMM_GET_PTE             0
 #define DEBUG_RPC_VMM_GET_VSEG            0
+#define DEBUG_RPC_VMM_UNMAP_VSEG          0
 
 #define DEBUG_RWLOCK_TYPE                 0    // lock type (0 is undefined) 
@@ -163,4 +167,5 @@
 #define DEBUG_SYS_BARRIER                 0
 #define DEBUG_SYS_CLOSE                   0
+#define DEBUG_SYS_CLOSEDIR                0
 #define DEBUG_SYS_CONDVAR                 0
 #define DEBUG_SYS_DISPLAY                 0
@@ -176,9 +181,11 @@
 #define DEBUG_SYS_KILL                    0
 #define DEBUG_SYS_OPEN                    0
-#define DEBUG_SYS_MKDIR                   2
+#define DEBUG_SYS_OPENDIR                 0
+#define DEBUG_SYS_MKDIR                   0
 #define DEBUG_SYS_MMAP                    0
 #define DEBUG_SYS_MUNMAP                  0
 #define DEBUG_SYS_MUTEX                   0
 #define DEBUG_SYS_READ                    0
+#define DEBUG_SYS_READDIR                 0
 #define DEBUG_SYS_SEM                     0
 #define DEBUG_SYS_STAT                    0
@@ -207,6 +214,7 @@
 
 #define DEBUG_VFS_ADD_CHILD               0
+#define DEBUG_VFS_ADD_SPECIAL             1
+#define DEBUG_VFS_CHDIR                   0
 #define DEBUG_VFS_CLOSE                   0
-#define DEBUG_VFS_CHDIR                   0
 #define DEBUG_VFS_DENTRY_CREATE           0
 #define DEBUG_VFS_FILE_CREATE             0
@@ -215,7 +223,7 @@
 #define DEBUG_VFS_INODE_LOAD_ALL          0
 #define DEBUG_VFS_LINK                    0
-#define DEBUG_VFS_LOOKUP                  1
+#define DEBUG_VFS_LOOKUP                  0
 #define DEBUG_VFS_LSEEK                   0
-#define DEBUG_VFS_MKDIR                   1
+#define DEBUG_VFS_MKDIR                   0
 #define DEBUG_VFS_NEW_CHILD_INIT          0
 #define DEBUG_VFS_OPEN                    0
@@ -224,4 +232,5 @@
 
 #define DEBUG_VMM_CREATE_VSEG             0
+#define DEBUG_VMM_DELETE_VSEG             0
 #define DEBUG_VMM_DESTROY                 0
 #define DEBUG_VMM_FORK_COPY               0
@@ -233,5 +242,4 @@
 #define DEBUG_VMM_PAGE_ALLOCATE           0
 #define DEBUG_VMM_SET_COW                 0
-#define DEBUG_VMM_UNMAP_VSEG              0
 #define DEBUG_VMM_UPDATE_PTE              0
 
@@ -276,13 +284,14 @@
 #define LOCK_PROCESS_FDARRAY  27   // remote (Q)  protect array of open files in owner process 
 #define LOCK_FATFS_FREE       28   // remote (Q)  protect the FATFS context (free clusters)
-
-#define LOCK_PROCESS_THTBL    29   // local  (RW) protect local array of threads in a process 
-
-#define LOCK_MAPPER_STATE     30   // remote (RW) protect mapper state
-#define LOCK_VFS_SIZE         31   // remote (RW) protect inode state and associated mapper
-#define LOCK_VFS_FILE         32   // remote (RW) protect file descriptor state
-#define LOCK_VMM_VSL          33   // remote (RW) protect VSL (local list of vsegs)
-#define LOCK_VMM_GPT          34   // remote (RW) protect GPT (local page table)
-#define LOCK_VFS_MAIN         35   // remote (RW) protect vfs traversal (in root inode)
+#define LOCK_PROCESS_DIR      29   // remote (Q)  protect xlist of open directories in process
+
+#define LOCK_PROCESS_THTBL    30   // local  (RW) protect local array of threads in a process 
+
+#define LOCK_MAPPER_STATE     31   // remote (RW) protect mapper state
+#define LOCK_VFS_SIZE         32   // remote (RW) protect inode state and associated mapper
+#define LOCK_VFS_FILE         33   // remote (RW) protect file descriptor state
+#define LOCK_VMM_VSL          34   // remote (RW) protect VSL (local list of vsegs)
+#define LOCK_VMM_GPT          35   // remote (RW) protect GPT (local page table)
+#define LOCK_VFS_MAIN         36   // remote (RW) protect vfs traversal (in root inode)
 
 
@@ -338,8 +347,8 @@
 
 #define CONFIG_VFS_MAX_INODES               128        // max number of inodes per cluster
-#define CONFIG_VFS_MAX_NAME_LENGTH          32         // dentry name max length (bytes)
+#define CONFIG_VFS_MAX_NAME_LENGTH          56         // dentry name max length (bytes)
 #define CONFIG_VFS_MAX_PATH_LENGTH          256        // pathname max length (bytes)
 #define CONFIG_VFS_FREE_CLUSTERS_MIN        32         // min number of free clusters
-
+#define CONFIG_VFS_MAX_DENTRIES             63         // max number of dentries in one dir
 
 #define CONFIG_VFS_ROOT_IS_FATFS            1          // root FS is FATFS if non zero
@@ -397,5 +406,5 @@
 
 ////////////////////////////////////////////////////////////////////////////////////////////
-//                USER SPACE SEGMENTATION / all values are number of pages
+//                USER SPACE SEGMENTATION / all values are numbers of pages
 ////////////////////////////////////////////////////////////////////////////////////////////
 
